
--此类事做分享用的,分享到 FB 微信好友 朋友圈, 需达到高倍
--by js
--
require("sns_share/share_control")

RoomShareDialog = class(DialogBase);

-- shareKind  1. 高倍   2.  5连胜   3. 春天(暂时不做)
-- multiplier 倍数  在2、3情况无用
function RoomShareDialog:ctor(shareKind, multiplier)
	self.m_shareSuccessCloseBtn = 0
	self.m_shareKind = shareKind
	self.m_multiplier = multiplier
	local info = self:getOrdinaryInfo()
	self.m_path = gSavePath..info.name
	local room_share_dialog_layout = require("view/ddz/hall_scene/share/room_share_dialog_layout")
	self.m_scene = new(SceneEx, room_share_dialog_layout);
	self:setContentView(self.m_scene);

	self.m_root = self.m_scene:getRoot();

	self:findViews();
	self:createView();

	self:setListener()

	self:composeSharePic()  -- 保存lua界面
end

function RoomShareDialog:dtor()
end

----获取节点
function RoomShareDialog:findViews()

	self.m_bg_mark = self .m_root:getChildByName2("bg_mark")
	self.m_closeBtn = self.m_root:getChildByName2("btn_close");
	self.m_view_mutiplier = self.m_root:getChildByName2("view_mutiplier")
	self.m_txt_multiplier1 = self.m_root:getChildByName2("txt_multiplier1")
	self.m_my_head = self.m_root:getChildByName2("my_head")
	self.m_my_frame = self.m_root:getChildByName2("my_frame")
	self.m_my_frame_bg = self.m_root:getChildByName2("my_frame_bg")
	self.m_share_to = self.m_root:getChildByName2("share_to")
	self.m_fbBtn = self.m_root:getChildByName2("btn_fb")
	self.m_weiXinBtn = self.m_root:getChildByName2("btn_weixin")
	self.m_timeLineBtn = self.m_root:getChildByName2("btn_timeline")
	self.m_my_name = self.m_root:getChildByName2("my_name")
end


function RoomShareDialog:highTimesShare()
	--Log.d("RoomShareDialog_js_initViews_1")
	-- 1.设置头像  2. 设置名字  3.设置倍数  4.设置 分享到 属性
	-- self.m_my_head:setFile(GameCache.getMyHeadIcon());
	--1.设置头像
	local imageMask = require("libEffect.shaders.imageMask");
	local img = new(Image, "login/unlogin_head_icon.png");
	img:setFile(GameCache.getMyHeadIcon())
	local w,h = self.m_my_head:getSize()
	img:setSize(w,h)
	self.m_my_head:addChild(img)
	imageMask.applyToDrawing(img,{file = "sns_share/room/my_frame_bg.png"});

	--2.设置名字
	local name = GameCache.getMnick()
	--找到场次 獲取房間的等級
	local roomType = GameCache.getRoomType();
	local roomLevel = GameCache.getRoomLevel();
	--Log.d("RoomShareDialog:highTimesShare__js__1", "roomType: " .. roomType .. " roomLevel: " .. roomLevel)
	local roomname= TableConfig.getDataFromGzBykey(roomType, roomLevel, "roomname"); --获取房间的场次
	local roomname_ = roomname or ""
	if roomType_ == GameCache.ROOMTYPE_PRIVATE_DDZ3 then
		self.name1 = string.format("恭喜%s\n在%s中", name, "私人场")
	else
		self.name1 = string.format("恭喜%s\n在%s中", name, roomname_)
	end

	self.m_my_name:setText(self.name1)
	self.m_my_name:setColor(255,255,255)
	--TODO:設置字體大小
	--3.设置倍数
	local winStr = string.format("<font color=#ffffff size=56>%s</font><font color=#ffff14 size=56>%d</font><font color=#ffffff size=56>%s</font>", "打出", self.m_multiplier, "倍" )
	local w, h = self.m_txt_multiplier1:getSize()
	local richTx = new(DrawingLabel)
	richTx:setRichText(winStr)
	richTx:setAlign(kAlignLeft)
	self.m_txt_multiplier1:removeAllChildren(true)
	self.m_txt_multiplier1:addChild(richTx)
	--TODO:4.设置 分享到 属性

end

function RoomShareDialog:setListener()
    self.m_closeBtn:setOnClick(self,self.onCloseBtnClick)
    self.m_weiXinBtn:setOnClick(self,self.onShareWeixin)	--微信分享按钮
 	self.m_fbBtn:setOnClick(self,self.onShareFB)			--FB分享按钮
    self.m_timeLineBtn:setOnClick(self,self.onShareTimeline)	--朋友圈分享按钮

end

function RoomShareDialog:createView()

	if self.m_shareKind == kHighTimesShare then		--高倍分享
		self:highTimesShare()
	elseif self.m_shareKind == kMultiWinShare then	--连胜
		self:multiWinShare()
	-- elseif self.m_shareKind == kSpringShare then
	-- 	self:springShare()
	end
end

function RoomShareDialog:multiWinShare(  )
	--连胜分享
	self.m_view_mutiplier:setVisible(false)
	self.m_my_frame_bg:setVisible(false)
	self.m_my_head:setVisible(false)
	self.m_my_frame:setVisible(false)
	self.m_bg_mark:setFile("sns_share/room/bg_multi_win.png")

end


	--点击关闭窗口
function RoomShareDialog:onCloseBtnClick()
	local  whoShare = RoomGameOverUI.whoShare
	if whoShare == "highTimes" then
		if self.m_shareSuccessCloseBtn == 0 then		--高倍时没有点击过分享按钮
			Flurry.Event(Flurry.kNO_SHARE_CLOSE_BTN_HIGHTIMESSHARE);
			-- --Log.d("RoomShareDialog:onCloseBtnClick__js__close: 高倍没有分享点击的关闭")
		elseif self.m_shareSuccessCloseBtn == 1 then  --点击过任何分享按钮后
			-- --Log.d("RoomShareDialog:onCloseBtnClick__js__close: 高倍分享后点击的关闭")
		else
			--Log.d("RoomShareDialog:异常退出")
		end

	elseif whoShare == "liansheng" then
		if self.m_shareSuccessCloseBtn == 0 then		--连胜时没有点击过分享按钮
			Flurry.Event(Flurry.kNO_SHARE_CLOSE_BTN_MULTISHARE);
			-- --Log.d("RoomShareDialog:onCloseBtnClick__js__close:连胜没有分享点击的关闭")
		elseif self.m_shareSuccessCloseBtn == 1 then  --连胜时点击过任何分享按钮后
			-- --Log.d("RoomShareDialog:onCloseBtnClick__js__close: 连胜分享后点击的关闭")
		else
			--Log.d("RoomShareDialog:异常退出")
		end
	else
	end

	self:close()
end



function RoomShareDialog:getOrdinaryInfo()
	-- --Log.d("RoomShareDialog:getOrdinaryInfo__1")
	local info = {
		sharetitile = {
			[kHighTimesShare] = "測智商！這局牌你能打出多少倍？",
			[kMultiWinShare] = "你比得過我嗎?",
			-- [kSpringShare] = "帮我看看这局牌怎么破！"
		},
		summary = {
			[kHighTimesShare] = string.format("我剛剛打出了%d倍，你行嗎？", self.m_multiplier),
			[kMultiWinShare] = "我在[博雅鬥地主]打出了5連勝，不服來鬥！",
			-- [kSpringShare] = "这局牌竟然春天了！你有办法破解吗？"
		},
		isLocalImg = false,
		webUrl = "http://ddz.boyaagame.com/",
		-- imagePath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/image_a.png?v=1", -- 放置分享图片的路径
		imagePath ="https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/image_b.png",
		FBimagePath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/gr_share_2.png?v=2", --缩略图
		name = "sns_share/shareBitmap.png", -- 放置分享图片的默认路径(本地保存的)

	}
	return info
end


function RoomShareDialog:onShareWeixin()
	--Log.d("RoomShareDialog:onShareWeixin_1")
	self.m_shareSuccessCloseBtn = 1 --有点击微信分享按钮
	local  whoShare = RoomGameOverUI.whoShare
	if  whoShare == "highTimes" then
		Flurry.Event(Flurry.kWINXIN_FRIEND_CLICK_HIGHTIMESSHARE);
		--Log.d("RoomShareDialog:onShareWeixin__js__highTimes")
	elseif whoShare == "liansheng" then
		Flurry.Event(Flurry.kWINXIN_FRIEND_CLICK_MULTISHARE);
		--Log.d("RoomShareDialog:onShareWeixin__js__liansheng")
	else
	end

	local weiXininfo = self:getOrdinaryInfo()
	ShareControl:shareToWeixin(weiXininfo.sharetitile[self.m_shareKind], weiXininfo.summary[self.m_shareKind], weiXininfo.imagePath, weiXininfo.webUrl, self.onShareResult, self, false)
end

--分享到微信朋友圈
function RoomShareDialog:onShareTimeline()
	self.m_shareSuccessCloseBtn = 1 --有点击微信朋友圈分享按钮

	local  whoShare = RoomGameOverUI.whoShare
	if  whoShare == "highTimes" then
		Flurry.Event(Flurry.kWINXIN_TIMELINE_CLICK_HIGHTIMESSHARE);
		--Log.d("RoomShareDialog:onShareTimeline__js__highTimes")
	elseif whoShare == "liansheng" then
		Flurry.Event(Flurry.kWINXIN_TIMELINE_CLICK_MULTISHARE );
		--Log.d("RoomShareDialog:onShareTimeline__js__liansheng")
	else
	end

	local info = self:getOrdinaryInfo()
	local isLocalImg = true; --朋友圈分享, 分享本地图片
	--type    imgUrl    circleOfFriends
	local circleOfFriends = true

    ShareControl:shareToWeixinTimeline(2, info.name, circleOfFriends, self.onShareResult, self, isLocalImg)
	--Log.d("RoomShareDialog___js_Timeline")
end

-- 将lua的界面保存成png 路径为 self.m_path
function RoomShareDialog:composeSharePic()

	local widget = self.m_bg_mark:getWidget()
	local w,h = self.m_bg_mark:getSize()
	local p = widget.pos
	widget.pos = Point(0,0)
	widget.scale = Point(1/System.getLayoutScale(),1/System.getLayoutScale())
	local fbo = FBO.create(Point(w,h))
	fbo:render(widget)
	os.mkdir(gSavePath.."sns_share")
	fbo:save(self.m_path)
	widget.scale = Point(1,1)
	widget.pos = p

end


--Facebook分享
function RoomShareDialog:onShareFB()
	self.m_shareSuccessCloseBtn = 1 --有点击Facebook分享按钮

	local  whoShare = RoomGameOverUI.whoShare
	if  whoShare == "highTimes" then
		Flurry.Event(Flurry.kFB_CLICK_HIGHTIMESSHARE );
		--Log.d("RoomShareDialog:onShareFB__js__highTimes")
	elseif whoShare == "liansheng" then
		Flurry.Event(Flurry.kFB_CLICK_MULTISHARE );
		--Log.d("RoomShareDialog:onShareFB__js__liansheng")
	else
	end

	--Log.d("RoomShareDialog:onShareFB__js__1", self.m_shareTypeName)
	local FBinfo = self:getOrdinaryInfo()
	----shareType  title  contentDesc   contentUrl 分享链接地址   imgUrl 分享链接的缩略图
	ShareControl:shareToFB(FBinfo.sharetitile[self.m_shareKind], FBinfo.summary[self.m_shareKind], FBinfo.FBimagePath, FBinfo.webUrl, self.onShareResult , self, false)

end


function RoomShareDialog:onShareResult(result)
	self.m_roomWhichShare = RoomGameOverUI.m_whichShare;
	-- --Log.d("RoomShareDialog__js__m_roomWhichShare:", self.m_roomWhichShare)
	local shareWay = NativeEvent.shareWay	--获取之前存的分享方式: "WeixinTimeline"  "Weixin"  "FaceBook"
	-- --Log.d("RoomShareDialog__js_shareWay:", shareWay)

	if self.m_roomWhichShare == "my_highTimesShare" then	--高倍分享
		--Log.d("RoomShareDialog:onShareResult__js__高倍分享开始:_m_whichShare:")
		if result == 1 then
			if shareWay == "FaceBook" then		--FB 分享成功
				-- --Log.d("RoomShareDialog:onShareResult__js__1_whichShare: ")
				Flurry.Event(Flurry.kFB_SHARE_SUCCESS_HIGHTIMESSHARE);
			elseif shareWay == "Weixin" then	--微信好友分享成功
				Flurry.Event(Flurry.kWEIXIN_SHARE_SUCCESS_HIGHTIMESSHARE);
				-- --Log.d("RoomShareDialog:onShareResult__js__2_whichShare: ")
			elseif shareWay == "WeixinTimeline" then	--微信朋友圈分享成功
				Flurry.Event(Flurry.kWEIXIN_TIMELINE_SUCCESS_HIGHTIMESSHARE);
				-- --Log.d("RoomShareDialog:onShareResult__js__3_whichShare: ")
			else
			end
			-- self:close()	--分享成功后关闭弹窗
		elseif result == 0 then
			-- self:close()
			--Log.d("RoomShareDialog:onShareResult__js__4_whichShare:取消分享 ")
		else
			--Log.d("RoomShareDialog:onShareResult__js__5——分享失败")
		end

	elseif self.m_roomWhichShare == "my_multiShare" then  -- 连胜分享
		-- --Log.d("RoomShareDialog:onShareResult__js__连胜分享开始:_m_whichShare:")
		if result == 1 then
			if shareWay == "FaceBook"   then		--FB 分享成功
				Flurry.Event(Flurry.kFB_SHARE_SUCCESS_MULTISHARE);
				-- --Log.d("RoomShareDialog:onShareResult__js__8_whichShare: ")
			elseif shareWay == "Weixin"  then		--微信好友分享成功
				Flurry.Event(Flurry.kWEIXIN_SHARE_SUCCESS_MULTISHARE);
				-- --Log.d("RoomShareDialog:onShareResult__js__6_whichShare: ")
			elseif shareWay == "WeixinTimeline"   then --微信朋友圈分享成功
				Flurry.Event(Flurry.kWEIXIN_TIMELINE_SUCCESS_MULTISHARE);
				-- --Log.d("RoomShareDialog:onShareResult__js__7_whichShare: ")
			else
			end
			-- self:close()  --分享成功后关闭弹窗
		elseif result == 0 then
			-- self:close()
			--Log.d("RoomShareDialog:onShareResult__js__9_whichShare:取消分享 ")
		else
			--Log.d("RoomShareDialog:onShareResult__js__10——分享失败:")
		end

	else
		--Log.d("RoomShareDialog: 高倍连胜都没走到")
	end

end
