
--分享的控制类
--by js

ShareControl = class()

function ShareControl:weixinShare(shareType, title, desc, imgUrl, webUrl, shareFriend, imagePathType, callback, obj)
    local appid = string_get("wx_app_id")
    webUrl = webUrl or "http://ddz.boyaagame.com/"
    if type(imagePathType) ~= "number" then
        imagePathType = imagePathType and 1 or 0
    end
    title = title or "博雅鬥地主"
    -- --Log.d("ShareControl:weixinShare_2", appid, shareType, title, desc, imgUrl, webUrl, shareFriend, imagePathType, callback)
    NativeEvent.shareToWeixin(appid, shareType, title, desc, imgUrl, webUrl, shareFriend, callback, obj)
end

--分享给微信好友
function ShareControl:shareToWeixin(title, desc, imgPath, webpageUrl, callback, obj, isLocalPath)

    --Log.d("ShareControl:shareToWeixin__js__",GameCache.getWxAvailable())
    if not GameCache.getWxAvailable() then
		NoticeUtil.BannerNotice("分享失败，未安装微信应用！")
		return
	end
    local isLocalPath = false;
    --分享文本：1 --分享图片：2 --分享网页：3
	self:weixinShare(3, title, desc, imgPath, webpageUrl, false, isLocalPath, callback, obj)
end

function ShareControl:weixinTimeLineShare(shareType, imgPath, circleOfFriends, callback, obj, imagePathType)
    local appid = string_get("wx_app_id")

    if type(imagePathType) ~= "number" then
        imagePathType = imagePathType and 1 or 0
    end
    title = title or "博雅鬥地主"
    -- --Log.d("ShareControl:weixinTimeLineShare_2", appid, imgPath, circleOfFriends, callback)
    NativeEvent.shareToWeixinTimeline(appid, shareType, imgPath, circleOfFriends, callback, obj, imagePathType)
end

--分享到微信朋友圈
function ShareControl:shareToWeixinTimeline(type, imgPath, circleOfFriends, callback, obj, isLocalPath)
    --Log.d("ShareControl:shareToWeixinTimeline__js__")
    if not GameCache.getWxAvailable() then
        NoticeUtil.BannerNotice("分享失败，未安装微信应用！")
        return ;
    end
    if not GameCache.getWxTimelineSupport() then
        NoticeUtil.BannerNotice("分享失败，您的微信不支持分享到朋友圈！");
        return ;
    end
    self:weixinTimeLineShare(2, imgPath, true , callback, obj, isLocalPath)
end


function ShareControl:FBShare(shareType, title, desc, imgUrl, contentUrl, callback, obj)
    webUrl = webUrl or "http://ddz.boyaa.com"
    title = title or "博雅鬥地主"
    -- --Log.d("ShareControl:FBShare_2", shareType, title, desc, imgUrl, webUrl, callback)
    NativeEvent.shareToFB(shareType, title, desc, imgUrl, contentUrl, callback, obj)
end


--分享到Facebook朋友圈
function ShareControl:shareToFB(title, contentDesc, imgUrl, contentUrl, callback, obj, isLocalPath)
    --这里如果手机没有安装Facebook, SDK那边会默认的弹出窗口来登录Facebook,然后分享
    --shareType  title  contentDesc   contentUrl 分享链接地址   imgUrl 分享链接的缩略图
    --分享链接：0  --分享图片：1
    self:FBShare(0, title, contentDesc, imgUrl, contentUrl, callback, obj)
    -- --Log.d("ShareControl:shareToWeixin__2", callback)
end

